if (typeof console == "undefined"){
	window.console = {log: function(){}};
}


$(document).ready(function(){


	  // Handle sparklines:
	  metricCharts();

	  // Handle the main chart
	  mainChart();

	// Generic ie8 fixing:
	if (ltie9){
		$("body").addClass("lt-ie9").removeClass("ieIconsFix"); // for ie8 debugging on ie11
		$("#dashMetrics .group .metric:last-child").addClass("last-child");
	}
	else {

	}

	// Hoverintent for nav
	$("#navs .dropdown").hoverIntent({
		over: function(){
			$(this).addClass("hover").siblings().removeClass("hover").find(".subnav").fadeOut(200);
			$(this).addClass("hover").find(".subnav").fadeIn(100);
		},
		out: function(){
			$(this).removeClass("hover").find(".subnav").fadeOut(200);
		},
		timeout: 400,
		interval: 50
	});

	// Click / Hoverintent for acct dropdown
	$("#acctMeta.droppable").click(function(){
		if ($(this).hasClass("dropped")){
			$(this).removeClass("dropped").find(".subnav").fadeOut(200);
		}
		else {
			$(this).addClass("dropped").find(".subnav").fadeIn(100);
		}
	})
	.hoverIntent({
		over: function(){},
		out: function(){
			if ($(this).hasClass("dropped")){
				$(this).removeClass("dropped").find(".subnav").fadeOut(200);
			}
		},
		timeout: 1000,
		interval: 50
	});

	// Clicks for select menus
	$(".select").click(function(){
		$(this).toggleClass("active");
	})

	// Category picker (custom)
	$("#catPicker").click(function(e){
		e.stopPropagation();
		$("#catDrop").toggleClass("hidelt");
	});
	$("#catDrop").click(function(e){
		e.stopPropagation();
	});
	$("body").click(function(){
		$("#catDrop").addClass("hidelt");
		$("#catPicker").removeClass("active");
	});
	$("#catDrop .dropRow").click(function(){
		var id = $(this).attr("id");
		var isSelected = $(this).hasClass("isSelected");

		// Special logic for "All Cats"
		if (id == "allCatDrop"){
			// Only proceed if it's not already in on-state
			if (!isSelected){

				// Turn everything off
				$.each(hl.cats, function(k,v){
					$("#" + k).removeClass("isSelected");
					v.selected = false;
				});

				$(this).addClass("isSelected");
				hl.cats.allCatDrop.selected = true;

			}
		}

		// Regular logic for others
		else {

			if (typeof hl.cats[id] == "undefined"){
				hl.cats[id] = {};
			}

			if (isSelected){
				delete hl.cats[id];

			}
			else {
				hl.cats[id].selected = true;
			}

			// Turn everything off
			var catCount = 0;
			$.each(hl.cats, function(k,v){
				if (v.selected && k !== "allCatDrop"){
					catCount++;
				}
			});
			console.log(catCount);
			if (catCount == 0){
				hl.cats.allCatDrop.selected = true;
				$("#allCatDrop").addClass("isSelected");
			} else {
				hl.cats.allCatDrop.selected = false;
				$("#allCatDrop").removeClass("isSelected");
			}

			$(this).toggleClass("isSelected");
		}

		// Stringify object of categories for ajax call
		if (hl.cats.allCatDrop.selected === true){
			hl.chart.opts.cats = "allCats"
		}
		else {	
			hl.chart.opts.cats = "";
			var length = hl.cats.length;
			var i = 0;
			$.each(hl.cats, function(k,v){
				if (k !== "allCatDrop"){
					hl.chart.opts.cats += k + "+";
				}
			});	
			hl.chart.opts.cats = hl.chart.opts.cats.substring(0, hl.chart.opts.cats.length - 1);
		}

		metricCharts();
		mainChart();
	});

	// Date range picker
    $("#dateRangePicker .dateRange").text(moment().subtract('days', 29).format('MMM D, YYYY') + " - " + moment().format('MMM D, YYYY'));
    
    $('#dateRangePicker').daterangepicker(
        {
          ranges: {
             'Last 7 Days': [moment().subtract('days', 6), moment()],
             'Last 30 Days': [moment().subtract('days', 29), moment()],
             'This Month': [moment().startOf('month'), moment().endOf('month')],
             'Last Month': [moment().subtract('month', 1).startOf('month'), moment().subtract('month', 1).endOf('month')]
          },
          startDate: moment().subtract('days', 29),
          endDate: moment(),
          maxDate: moment(),
          opens: 'left'

        },
        function(start, end) {
            $('#dateRangePicker .dateRange').html(start.format('MMM D, YYYY') + ' - ' + end.format('MMM D, YYYY'));
            $('#dateRangePicker .num').html(end.diff(start, 'days'));


            hl.chart.opts.startDate = start.format('L');
            hl.chart.opts.endDate = end.format('L');

			metricCharts();
			mainChart();
        }
    )
    .on('show', function(ev, picker){
        $("#customRangeLabel").click(function(){
            $(this).addClass("active").siblings().removeClass("active");
        })
    }).on('hide', function(ev, picker){
        $(this).removeClass("active");
    }).on('apply', function(ev, picker){
        console.log('Date selected');
        console.log('Start: ' + picker.startDate._d);
        console.log('End: ' + picker.endDate._d);
    });

	// Metric picker
	var $eachMetric = $("#dashMetrics .metric");
	$eachMetric.click(function(){
		setMetric($(this), $eachMetric);

	    // First handle the cumulatives / averages
	    switch (hl.chart.opts.metric)
	    {
	     // Straight numbers first
	     case "imps":
	     case "clicks":
	     case "spend": 
	     case "units": 
	     case "sales": 
	    	 hl.chart.opts.type = "stackedAreaChart";
	         break;

	     default: 
	    	 hl.chart.opts.type = "barChartWithTrend";
	         break;
	    }

	    mainChart();

	});

	$(window).debounce("resize", function(){setArrow();}, 100);

	// Set to clicks by default
	setMetric($("#clicksMetric"), $eachMetric);


	// Handle rightCol accordion clicks
	$("#rightCol .headBar, #rightCol .blockFooter").click(function(){
		var $thisBlock = $(this).parent(".dashBlock");
		var $items = $thisBlock.find(".items");
		var $expandedItems = $("#rightCol .expanded .items");
		if ($thisBlock.hasClass("expandable") || $thisBlock.hasClass("collapsed")){

			// Toggle expanded / collapsed states
			if ($thisBlock.hasClass("expanded") || $thisBlock.hasClass("collapsed")){
				$thisBlock.removeClass("expanded collapsed")
				.find(".items").slideDown().end()
				.find(".extended").slideUp().end()
				.siblings().removeClass("collapsed expanded").find(".items").slideDown().find(".extended").slideUp();
			}
			else {
				$thisBlock.removeClass("collapsed").addClass("expanded").find(".items, .extended").slideDown().end()
				.siblings().removeClass("expanded").addClass("collapsed").find(".items, .extended").slideUp();;
			}

			// Force a reflow to get rid of scrollbar space in chrome
			$expandedItems.css("display", "none").height();
			$expandedItems.css("display","block");

		}
	});



});

// Set a clicked metric
function setMetric($this, $eachMetric){

		$eachMetric.removeClass("active");
		$this.addClass("active");

		// Set arrow position
		setArrow($this);

		// Update stored var
		hl.chart.opts.metric = $this.attr("id").replace("Metric", "");

		console.log("Metric selected: " + $this.attr("id"));
}

// Move arrow to clicked metric
function setArrow($this){
	if (typeof $this == "undefined"){
		$this = $("#dashMetrics .metric.active")
	}

	var offset = $this.offset().left;
	offset = offset + ($this.width()/2) - 30;
	$("#chartTopper .arrow-up").css("left", offset); 
}
